// (C) 2003 Ulrich Hecht <uli@emulinks.de>
// if2a patch by D. Gauchard <deyv@free.fr>
// Licensed under the terms of the GNU Public License version 2

#include "f2a.h"
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <stdio.h>

#include "mb.bin-src.h"

int f2a_boot (void)
{
	sendmsg sm;
	unsigned int ack[16];
	
	int i;

	memset(&sm, 0, sizeof(sm));

	// boot the GBA
	sm.command=CMD_MULTIBOOT1;
	sendf2a(sm);
	sm.command=CMD_MULTIBOOT2;
	sm.size=16*1024;
	sendf2a(sm);
	
	// send the multiboot image
	for(i=0;i<16;i++)
		if(usb_write(mb_bin+i*1024, 1024)==-1) return -1;
	
	if(usb_read((char*)ack, 16*sizeof(int))==-1) return -1;

	if(verbose>=2)
	{
		printf("post-boot:");
		for(i=0;i<16;i++)
			printf(" %08X", ack[i]);
		puts("");
	}

	return 0;
}

