// (C) 2003 Ulrich Hecht <uli@emulinks.de>
// if2a patch by D. Gauchard <deyv@free.fr>
// Licensed under the terms of the GNU Public License version 2

#include "f2a.h"
#include <fcntl.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

int f2a_readmem(unsigned char* data, int address, int size)
{
	int i;
	sendmsg sm;

	assert((size & (LOADUNIT - 1)) == 0);

	memset(&sm, 0, sizeof(sm));
	sm.command=CMD_READDATA;
	sm.magic=MAGIC_NUMBER;
	sm.unknown=7;
	sm.address=address;
	sm.size=size;
	sm.sizekb=size/1024;

	if (sim > 1)
		return -1;
		
	if (sendf2a(sm)==-1)
		return -1;
	
	for (i = 0; i < sm.size; i += LOADUNIT)
	{
		if (usb_read(data, LOADUNIT)==-1)
			return -1;
		data += LOADUNIT;
	}
	return 0;
}

int f2a_readmemtofile(char* file, int address, int size)
{
	int f,i;
	sendmsg sm;
	unsigned char data[LOADUNIT];

	assert((size & (LOADUNIT - 1)) == 0);

	memset(&sm, 0, sizeof(sm));

	if (sim > 1)
		return -1;
		
	if ((f = open(file, O_WRONLY|O_CREAT|O_TRUNC, 0644)) == -1)
	{
		perror(file);
		return -1;
	}

	sm.command=CMD_READDATA;
	sm.magic=MAGIC_NUMBER;
	sm.unknown=7;
	sm.address=address;
	sm.size=size;
	sm.sizekb=size/1024;
	if(sendf2a(sm)==-1) return -1;
	
	for (i = 0; i < sm.size; i += LOADUNIT)
	{
		if (usb_read(data, LOADUNIT) == -1)
		{
			close(f);
			return -1;
		}
		if (write(f, data, LOADUNIT) == -1)
		{
			perror(file);
			close(f);
			return -1;
		}
	}
	close(f);
	return 0;
}
